module RemoveListComp where
import Substitute
import Recursive
import HasBaseStruct
import BaseSyntax
import SrcLoc
import DerivingUtils(alt1,oneDef,mod_PreludeList)
import TiNames(ValueId,localVal',topVal)
import TiClasses(HasDef)

rmAllListComp m = mapExp rmListComp m

class RmListComp s where
  rmListComp :: s -> s

instance RmListComp s => RmListComp [s] where rmListComp = map rmListComp

rmListCompE e = rmListCompE' rec e

rmListCompE' rec e0 =
    case mapEI id rmListComp id rmAllListComp id id e0 of
      HsListComp stmt -> compileListComp stmt
      e -> rec e

{-+
Translation of list comprehensions, as described in section 3.11
of the Haskell 98 report
-}
{-
compileListComp ::
   (ValueId i,
    HasBaseStruct e (EI i e p ds t c),
    HasBaseStruct p (PI i p),
    HasBaseStruct d (DI i e p ds t c tp),
    HasDef ds d)
  => HsStmt e p ds -> e
-}
compileListComp stmt =
  case stmt of
    HsGenerator s p e stmt ->
         hsLet okDef (hsEVar concatMap `hsApp` hsEVar ok `hsApp` e)
       where
         concatMap = topVal mod_PreludeList "concatMap"
	 ok = localVal' "ok" (Just s) -- should be a fresh variable
	 okDef = oneDef (hsFunBind loc0 okEqns)
	 okEqns = [okM p (compileListComp stmt),
	           okM hsPWildCard (hsList [])]
	 okM = alt1 loc0 ok

    HsQualifier e stmt -> hsIf e (compileListComp stmt) (hsList []) 
    HsLetStmt ds stmt -> hsLet ds (compileListComp stmt)
    HsLast e -> hsList [e]
