module CertCmd where
import PFE_Certs(QCertName(..))
import PrettyPrint(pp)

data CertCmd
   = ValidateCert QCertName
   | RemoveCert QCertName
   | NewCert String QCertName String
   | TodoCert
   deriving (Eq,Show)

--isValidate ValidateCert{} = True
--isValidate _ = False

cmdCert (ValidateCert cert) = Just cert
cmdCert (RemoveCert cert) = Just cert
cmdCert (NewCert ty cert concl) = Just cert
cmdCert _ = Nothing

shellCmd (ValidateCert cert) = "cert validate "++quote (ppqcert cert)
shellCmd (RemoveCert cert) = "cert rm "++quote (ppqcert cert)
shellCmd (NewCert ty cert concl) =
    unwords ["cert new",ty,quote (ppqcert cert),quote concl]
shellCmd TodoCert = "cert todo"

ppqcert (QCertName m c) = pp m++"/"++c

quote s = q++s++q where q="\""
